unit WinAdd;

{$IMPORTEDDATA OFF}
{$MINENUMSIZE 4}

interface

uses Windows;

type
// basetsd.h
  UINT32 = Cardinal;
  UINT_PTR = Cardinal;
  ULONG_PTR = Cardinal;
  ULONGLONG = Int64; // XXX Delphi 6 not supported unsigned 64bit integer
  ULONG64 = Int64;
  KAFFINITY = ULONG_PTR;

// windef.h
  USHORT = Word;

// intsafe.h
  DWORDLONG = ULONGLONG;

// winternl.h
  NTSTATUS = Longint;

// ntdef.h
  REPARSE_DATA_BUFFER = record
    ReparseTag: ULONG;
    ReparseDataLength: USHORT;
    Reserved: USHORT;
    case Integer of
      0: (SymbolicLinkReparseBuffer: record
            SubstituteNameOffset: USHORT;
            SubstituteNameLength: USHORT;
            PrintNameOffset: USHORT;
            PrintNameLength: USHORT;
            Flags: ULONG;
            PathBuffer: array [0..0] of WCHAR;
          end);
      1: (MountPointReparseBuffer: record
            SubstituteNameOffset: USHORT;
            SubstituteNameLength: USHORT;
            PrintNameOffset: USHORT;
            PrintNameLength: USHORT;
            PathBuffer: array [0..0] of WCHAR;
          end);
      2: (DataBuffer: array [0..0] of UCHAR);
  end;
  PREPARSE_DATA_BUFFER = ^REPARSE_DATA_BUFFER;

const
  // winbase.h
  STARTF_TITLEISLINKNAME = $00000800;
  FILE_FLAG_OPEN_REPARSE_POINT = $200000;

  // wingdi.h
  CLEARTYPE_QUALITY = 5;

  // urlmon.h
  INET_E_RESOURCE_NOT_FOUND = $800c0005;
  INET_E_OBJECT_NOT_FOUND = $800c0006;
  INET_E_DOWNLOAD_FAILURE = $800c0008;


// winnt.h

type
  PCWSTR = PWideChar;
  PWSTR = PWideChar;
  PULARGE_INTEGER = ^ULARGE_INTEGER;

  ACL_SIZE_INFORMATION = record
    AceCount: DWORD;
    AclBytesInUse: DWORD;
    AclBytesFree: DWORD;
  end;

  ACE_HEADER = record
    AceType: Byte;
    AceFlags: Byte;
    AceSize: Word;
  end;

  ACCESS_ALLOWED_ACE = record
    Header: ACE_HEADER;
    Mask: ACCESS_MASK;
    SidStart: DWORD;
  end;
  PACCESS_ALLOWD_ACE = ^ACCESS_ALLOWED_ACE;

  LOGICAL_PROCESSOR_RELATIONSHIP = (
    RelationProcessorCore = 0,
    RelationNumaNode = 1,
    RelationCache = 2,
    RelationProcessorPackage = 3,
    RelationGroup = 4,
    RelationAll = $ffff
  );

  GROUP_AFFINITY = record
    Mask: KAFFINITY;
    Group: Word;
    Reserved: array [0..2] of Word;
  end;

  PROCESSOR_RELATIONSHIP = record
    Flags: Byte;
    EfficiencyClass: Byte;
    Reserved: array [0..19] of Byte;
    GroupCount: Word;
    GroupMask: array[0..0] of GROUP_AFFINITY;
  end;

  SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX = record
    Relationship: LOGICAL_PROCESSOR_RELATIONSHIP;
    Size: DWORD;
    Processor: PROCESSOR_RELATIONSHIP;
  end;
  PSYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX = ^SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX;

const
  ACCESS_ALLOWED_ACE_TYPE = 0;

  IO_REPARSE_TAG_MOUNT_POINT = $a0000003;
  IO_REPARSE_TAG_SYMLINK = $a000000c;

  FILE_ATTRIBUTE_REPARSE_POINT = $400;

  // File access rights
  FILE_READ_DATA = $0001;
  FILE_WRITE_DATA = $0002;
  FILE_EXECUTE = $0020;


// winioctl.h

type
  STORAGE_PROPERTY_ID = (
    StorageAdapterProtocolSpecificProperty = 49,
    StorageDeviceTemperatureProperty = 52
  );

  STORAGE_QUERY_TYPE = (
    PropertyStandardQuery,
    PropertyExistsQuery,
    PropertyMaskQuery,
    PropertyQueryMaxDefined
  );

  STORAGE_PROPERTY_QUERY = record
    PropertyId: STORAGE_PROPERTY_ID;
    QueryType: STORAGE_QUERY_TYPE;
    AdditionalParameters: array [0..0] of Byte;
  end;
  PSTORAGE_PROPERTY_QUERY = ^STORAGE_PROPERTY_QUERY;

  STORAGE_PROTOCOL_TYPE = (
    ProtocolTypeUnknown,
    ProtocolTypeScsi,
    ProtocolTypeAta,
    ProtocolTypeNvme,
    ProtocolTypeSd,
    ProtocolTypeUfs,
    ProtocolTypeProprietary,
    ProtocolTypeMaxReserved
  );

  STORAGE_PROTOCOL_NVME_DATA_TYPE = (
    NVMeDataTypeUnknown,
    NVMeDataTypeIdentify,
    NVMeDataTypeLogPage,
    NVMeDataTypeFeature
  );

  STORAGE_PROTOCOL_SPECIFIC_DATA = record
    ProtocolType: STORAGE_PROTOCOL_TYPE;
    DataType: DWORD;
    ProtocolDataRequestValue: DWORD;
    ProtocolDataRequestSubValue: DWORD;
    ProtocolDataOffset: DWORD;
    ProtocolDataLength: DWORD;
    FixedProtocolReturnData: DWORD;
    ProtocolDataRequestSubValue2: DWORD;
    ProtocolDataRequestSubValue3: DWORD;
    Reserved: DWORD;
  end;
  PSTORAGE_PROTOCOL_SPECIFIC_DATA = ^STORAGE_PROTOCOL_SPECIFIC_DATA;

  STORAGE_TEMPERATURE_INFO = record
    Index: Word;
    Temperature: SHORT;
    OverThreshold: SHORT;
    OverThresholdChangable: Boolean;
    UnderThresholdChangable: Boolean;
    EventGenerated: Boolean;
    Reserved0: Byte;
    Reserved1: DWORD;
  end;

  STORAGE_TEMPERATURE_DATA_DESCRIPTOR = record
    Version: DWORD;
    Size: DWORD;
    CriticalTemperature: SHORT;
    WarningTemperature: SHORT;
    InfoCount: Word;
    Reserved0: array [0..1] of Byte;
    Reserved1: array [0..1] of DWORD;
    TemperatureInfo: array [0..0] of STORAGE_TEMPERATURE_INFO;
  end;
  PSTORAGE_TEMPERATURE_DATA_DESCRIPTOR = ^STORAGE_TEMPERATURE_DATA_DESCRIPTOR;

const
  FILE_DEVICE_FILE_SYSTEM = 9;
  FILE_ANY_ACCESS = 0;
  METHOD_BUFFERED = 0;
  FSCTL_GET_REPARSE_POINT = FILE_DEVICE_FILE_SYSTEM shl 16 or
      FILE_ANY_ACCESS shl 14 or 42 shl 2 or METHOD_BUFFERED;
  IOCTL_STORAGE_QUERY_PROPERTY = $2d1400;


// nvme.h

type
  NVME_LOG_PAGES = (
    NVME_LOG_PAGE_HEALTH_INFO = $02
  );

  NVME_HEALTH_INFO_LOG = record
    {
      CriticalWarning bit fields:
        AvailableSpaceLow: 1
        ReliabilityDegraded: 1
        ReadOnly: 1
        VolatileMemoryBackupDeviceFailed: 1
        Reserved: 3
    }
    CriticalWarning: UCHAR;
    Temperature: array [0..1] of UCHAR;
    AvailableSpare: UCHAR;
    AvailableSpareThreshold: UCHAR;
    PercentageUsed: UCHAR;
    Reserved0: array [0..25] of UCHAR;
    DataUnitRead: array [0..15] of UCHAR;
    DataUnitWritten: array [0..15] of UCHAR;
    HostReadCommands: array [0..15] of UCHAR;
    HostWrittenCommands: array[0..15] of UCHAR;
    ControllerBusyTime: array [0..15] of UCHAR;
    PowerCycle: array [0..15] of UCHAR;
    PowerOnHours: array [0..15] of UCHAR;
    UnsafeShutdowns: array [0..15] of UCHAR;
    MediaErrors: array [0..15] of UCHAR;
    ErrorInfoLogEntryCount: array [0..15] of UCHAR;
    WarningCompositeTemperatureTime: ULONG;
    CriticalCompositeTemperatureTime: ULONG;
    TemperatureSensor1: USHORT;
    TemperatureSensor2: USHORT;
    TemperatureSensor3: USHORT;
    TemperatureSensor4: USHORT;
    TemperatureSensor5: USHORT;
    TemperatureSensor6: USHORT;
    TemperatureSensor7: USHORT;
    TemperatureSensor8: USHORT;
    Reserved1: array [0..295] of UCHAR;
  end;
  PNVME_HEALTH_INFO_LOG = ^NVME_HEALTH_INFO_LOG;

const
  NVME_NAMESPACE_ALL = $ffffffff;


// mmreg.h

type
  WAVEFORMATEX = packed record
    wFormatTag: Word;
    nChannels: Word;
    nSamplesPerSec: DWORD;
    nAvgBytesPerSec: DWORD;
    nBlockAlign: Word;
    wBitsPerSample: Word;
    cbSize: Word;
  end;
  PWAVEFORMATEX = ^WAVEFORMATEX;

const
  WAVE_FORMAT_UNKNOWN  = $0000;
  WAVE_FORMAT_PCM = $0001;
  WAVE_FORMAT_ADPCM = $0002;
  WAVE_FORMAT_WMAVOICE9 = $000a;
  WAVE_FORMAT_MPEG = $0050;
  WAVE_FORMAT_MPEGLAYER3 = $0055;
  WAVE_FORMAT_DOLBY_AC3_SPDIF = $0092;
  WAVE_FORMAT_RAW_AAC1 = $00ff;
  WAVE_FORMAT_MSAUDIO1 = $0160;
  WAVE_FORMAT_WMAUDIO2 = $0161;
  WAVE_FORMAT_WMAUDIO3 = $0162;
  WAVE_FORMAT_WMAUDIO_LOSSLESS = $0163;
  WAVE_FORMAT_MPEG_ADTS_AAC = $1600;
  WAVE_FORMAT_DVM = $2000;
  WAVE_FORMAT_OGG_VORBIS_MODE_1 = $674f;
  WAVE_FORMAT_OGG_VORBIS_MODE_2 = $6750;
  WAVE_FORMAT_OGG_VORBIS_MODE_3 = $6751;
  WAVE_FORMAT_OGG_VORBIS_MODE_1_PLUS = $676f;
  WAVE_FORMAT_OGG_VORBIS_MODE_2_PLUS = $6770;
  WAVE_FORMAT_OGG_VORBIS_MODE_3_PLUS = $6771;
  WAVE_FORMAT_OPUS = $704f;
  WAVE_FORMAT_FLAC = $f1ac;


// sysinfoapi.h

type
  MEMORYSTATUSEX = record
    dwLength: DWORD;
    dwMemoryLoad: DWORD;
    ullTotalPhys: DWORDLONG;
    ullAvailPhys: DWORDLONG;
    ullTotalPageFile: DWORDLONG;
    ullAvailPageFile: DWORDLONG;
    ullTotalVirtual: DWORDLONG;
    ullAvailVirtual: DWORDLONG;
    ullAvailExtendedVirtual: DWORDLONG;
  end;
  LPMEMORYSTATUSEX = ^MEMORYSTATUSEX;

function GlobalMemoryStatusEx(lpBuffer: LPMEMORYSTATUSEX): BOOL;
    stdcall; external kernel32;


// fileapi.h

function GetFileSizeEx(hFile: THandle; var FileSize: LARGE_INTEGER): BOOL;
    stdcall; external kernel32;
function SetFilePointerEx(hFile: THandle; DistanceToMove: LARGE_INTEGER;
    var NewFilePointer: LARGE_INTEGER; MoveMethod: DWORD): BOOL;
    stdcall; external kernel32;
// fix Windows unit declaration bug
function GetDiskFreeSpaceExW(lpDirectoryName: LPCWSTR;
    lpFreeBytesAvailableToCaller, lpTotalNumberOfBytes,
    lpTotalNumberOfFreeBytes: PULARGE_INTEGER): BOOL;
    stdcall; external kernel32;


// winuser.h

const
  WPF_ASYNCWINDOWPLACEMENT = $0004;
  EVENT_CONSOLE_UPDATE_REGION = $4002;
  EVENT_CONSOLE_UPDATE_SIMPLE = $4003;

// fix Windows unit declaration bug
function LoadCursorW(hInstance: HINST; lpCursorName: LPCWSTR): HCURSOR;
    stdcall; external user32;


// wincon.h
function GetConsoleWindow: HWND; stdcall; external kernel32;


// ntsecapi.h
// XP and later
function RtlGenRandom(RandomBuffer: Pointer; RandomBufferLength: ULONG): BOOL;
    stdcall; external advapi32 name 'SystemFunction036';


implementation
end.
